% Use dense correspondence to provide spatial information for pdftransfer

function IR=flowenhance_pdftransfer(im1, im2, im1_idx, im2_idx)
	col_im1 = reshape(im1, [size(im1,1)*size(im1,2) size(im1,3)]);
	col_im2 = reshape(im2, [size(im2,1)*size(im2,2) size(im2,3)]);
	pixels1 = col_im1(im1_idx, :);
	pixels2 = col_im2(im2_idx, :);

	D0=double(pixels1')/255;
	D1=double(pixels2')/255;

	nbiterations=20;

	% building a sequence of (almost) random projections

	Rs{1} = [1 0 0; 0 1 0; 0 0 1; 2/3 2/3 -1/3; 2/3 -1/3 2/3; -1/3 2/3 2/3];
	for i=2:nbiterations
		 Rs{i} = Rs{1} * orth(randn(3,3));
	end

	% pdf transfer
	[DR, T] = pdf_transfer(D0, D1, Rs);

	%---------------------------------------------------
	D0=double(col_im1')/255;
	D0R_=D0;
	nbiterations=20;
	nb_channels=3;
	% Rs{1} = [1 0 0; 0 1 0; 0 0 1; 2/3 2/3 -1/3; 2/3 -1/3 2/3; -1/3 2/3 2/3];
	% for i=2:nbiterations
	% 	 Rs{i} = Rs{1} * orth(randn(3,3));
	% end
	nb_dims = size(D0,1);
	nb_iterations = length(Rs);
	relaxation = 1;

	for it=1:nb_iterations
		R = Rs{it};    
		nb_projs = size(R,1);
		D0R = R * D0;
		f=T(it).f; scale=T(it).scale; datamin=T(it).datamin;
		for i=1:nb_projs
			D0R_(i,:) = interp1(0:length(f{i})-1, f{i}', (D0R(i,:) - datamin(i))*scale(i))/scale(i) + datamin(i);
		end
		D0 = relaxation * R \ (D0R_ - D0R) + D0;
	end
	DR = D0;
	IR = im2double(im1);
	for i=1:nb_channels
		IR(:,:,i) = reshape(DR(i,:), size(IR, 1), size(IR, 2));
	end
end
