function compute_flow_midbury(imgDir, flowDir, ids, scaleParams)
    % compute matching for middlebury dataset
    override = 0;
    conf = ssf_conf();

    parfor i=1:length(ids)
        imgId=ids{i};
        disp(imgId);

        % Load original size image
        im1 = imread([imgDir imgId '/frame10.png']);
        im2 = imread([imgDir imgId '/frame11.png']);

        if ~isempty(scaleParams)
            % Resize src, tgt image
            im1 = imresize(im1, scaleParams.srcRatio);
            im2 = imresize(im2, scaleParams.tgtRatio);
        end
        fname = [flowDir imgId '.ssf.mat'];

        if exist(fname, 'file') && ~override % Avoid to compute existed result
            continue;
        end

        [cFlow, scaleLabel, energy, iter] = ssf(im1, im2, conf);
        save_caller(fname, 'iter', iter);
    end
end