function eval_result_midbury(imgDir, flowDir, gtDir, ids, scaleParams)
    vis = 0;
    if ~isempty(scaleParams)
        disp('Scaled version of MiddleBury:');
    else
        disp('Original version of MiddleBury:');
    end

    fprintf('      Pair_name    AE          EPE\n');
    for i = 1:length(ids)
        imgId=ids{i};


        if ~isempty(scaleParams)
            gtFlow = load_gtflow([gtDir imgId '/flow10.flo'], scaleParams.srcRatio, scaleParams.tgtRatio);
        else
            gtFlow = load_gtflow([gtDir imgId '/flow10.flo']);
        end

        flowFname = [flowDir imgId '.ssf.mat'];
        if ~exist(flowFname, 'file'); continue; end;
        tmp = load(flowFname); iter = tmp.s.iter;
        cFlow=iter.steps(end).flow;
        scaleLabel=iter.steps(end).label;

        [epeMean, epeStd, angleMean, angleStd] = measure_error(cFlow, gtFlow);
        fprintf('%15s    %4.2f±%.2f     %4.2f±%4.2f\n', imgId,...
            angleMean, angleStd, epeMean, epeStd);
        clear('iter', 'tmp');

        if vis
            im1 = imread([imgDir imgId '/frame10.png']);
            im2 = imread([imgDir imgId '/frame11.png']);
            if ~isempty(scaleParams)
                % Resize src, tgt image
                im1 = imresize(im1, scaleParams.srcRatio);
                im2 = imresize(im2, scaleParams.tgtRatio);
            end
            plot_warp(im1, im2, cFlow, scaleLabel);
        end
    end
end