% Experiment on Middlebury dataset
clearvars; close all;

addpath('code/ssf');
addpath('code/benchmark');
addpath('code/util');
addpath('code/include/flow-code-matlab');

ssf_setup;
ssfConf = ssf_conf(); % load parameter
% Configure working directory
% input
imgDir='data/MiddleBury/other-data/';
gtDir='data/MiddleBury/other-gt-flow/';

% output
scaledFlowDir='output/midbury/mat/scaled/';
originFlowDir='output/midbury/mat/origin/';

for flowDir = {scaledFlowDir originFlowDir}
    if ~exist(flowDir{1}, 'dir'), mkdir(flowDir{1}); end
end

% Load img ids
fid=fopen('data/midbury_withgt.txt'); ids=textscan(fid, '%s'); fclose(fid); ids=ids{1}; 

scaleParams.srcRatio = 0.7; scaleParams.tgtRatio = 0.2;
compute_flow_midbury(imgDir, scaledFlowDir, ids, scaleParams);
eval_result_midbury(imgDir, scaledFlowDir, gtDir, ids, scaleParams);

compute_flow_midbury(imgDir, originFlowDir, ids, []);
eval_result_midbury(imgDir, originFlowDir, gtDir, ids, []);

