#!/bin/bash
nrdc()
{
	# From: http://www.cs.huji.ac.il/~yoavhacohen/nrdc/
	wget -c http://www.cs.huji.ac.il/~yoavhacohen/nrdc/code/NRDC.zip
	unzip NRDC.zip -d NRDC
}

siftflow()
{
	# From: http://people.csail.mit.edu/celiu/ECCV2008/
	wget -c http://people.csail.mit.edu/celiu/ECCV2008/release.zip
	unzip release.zip -d SiftFlow
	# http://www.thegeekstuff.com/2009/11/unix-sed-tutorial-append-insert-replace-and-count-file-lines/
	gsed -i '5 a\
	#define _LINUX_MAC' SiftFlow/release/mex/project.h
	mex SiftFlow/release/mex/mexDiscreteFlow.cpp SiftFlow/release/mex/BPFlow.cpp SiftFlow/release/mex/Stochastic.cpp 
	mv mexDiscreteFlow.* SiftFlow/release/
}

pdftransfer()
{
	# From: http://www.mee.tcd.ie/~sigmedia/Research/ColourGrading?from=Research.PDFTransfer  
	wget -c http://www.mee.tcd.ie/~sigmedia/pmwiki/uploads/Research.ColourGrading/Matlab_Colour_Transfer_using_IDT_Pitie07.zip 
	unzip Matlab_Colour_Transfer_using_IDT_Pitie07.zip -d pdf_transfer
	src=( patch/pdf_transfer.m patch/colour_transfer_IDT.m )
	tgt=( pdf_transfer/pdf_transfer.m pdf_transfer/colour_transfer_IDT.m )
	patch src[@] tgt[@]
}

SLMtools()
{
	echo	
}

SLS()
{
	wget -c http://www.openu.ac.il/home/hassner/projects/siftscales/sls_distribution.1.1.zip
	unzip sls_distribution.1.1.zip -d SLS
}

vlfeat()
{
	wget -c http://www.vlfeat.org/download/vlfeat-0.9.16.tar.gz
	tar -xvzf vlfeat-0.9.16.tar.gz
	ln -s vlfeat-0.9.16 vlfeat
	make -C vlfeat
}

flowcode()
{
	wget -c http://vision.middlebury.edu/flow/code/flow-code-matlab.zip
	unzip flow-code-matlab.zip
}

patch()
{ 
	declare -a src=("${!1}")
    declare -a tgt=("${!2}")
	# Ref: http://stackoverflow.com/questions/1063347/passing-arrays-as-parameters-in-bash
	for i in $(seq 0 $((${#src[@]} - 1)))
	do
		f1=${src[$i]}
		f2=${tgt[$i]}
		echo $f1 '->' $f2
		ln -f $f1 $f2
	done
}

mkdir -p include; cd include
vlfeat
flowcode
# pdftransfer
# nrdc
# SLS
